commit be1c07209156d1e0e1b7b977d291d8b68a250fa7
Author: Richard Earnshaw <rearnsha@arm.com>
Date:   Thu Jan 22 15:16:28 2026

    arm: fix unrecognized HFmode min/max insns on neon [PR123742]
    
    When expansion support for smin/smax was enabled (presumably for MVE)
    the corresponding Neon instructions were not updated to recognize the
    generated RTL.  This patch makes the necessary changes to recognize
    these variants.
    
    gcc/ChangeLog:
    
            PR target/123742
            * config/arm/neon.md (*smin<mode>3_neon): Renamed to ...
            (*smin<VDQWH:mode>3_neon): ... this.  Add HFmode support.
            (*smax<mode>3_neon): Renamed to ...
            (*smax<VDQWH:mode>3_neon): ... this.  Add HFmode support.
    
    gcc/testsuite/ChangeLog:
    
            PR target/123742
            * gcc.target/arm/neon-smax16.c: New test.
            * gcc.target/arm/neon-smin16.c: New test.
    
    (cherry picked from commit 412667e50077e4678e6d164bca91b6408749471f)

diff --git a/gcc/testsuite/gcc.target/arm/neon-smax16.c b/gcc/testsuite/gcc.target/arm/neon-smax16.c
new file mode 100644
index 00000000000..4fd36bb6648
--- /dev/null
+++ b/gcc/testsuite/gcc.target/arm/neon-smax16.c
@@ -0,0 +1,14 @@
+/* { dg-do compile } */
+/* { dg-require-effective-target arm_v8_2a_fp16_neon_ok } */
+/* { dg-add-options arm_v8_2a_fp16_neon } */
+/* { dg-additional-options "-std=c23 -Ofast" } */
+void foo(void);
+extern _Float16 main_in[];
+void bar() {
+  _Float16 out = 0.0;
+  for (int i = 0; i < 100; i++)
+    if (out < main_in[i])
+      out = main_in[i];
+  if (out)
+    foo();
+}
diff --git a/gcc/testsuite/gcc.target/arm/neon-smin16.c b/gcc/testsuite/gcc.target/arm/neon-smin16.c
new file mode 100644
index 00000000000..284f7023982
--- /dev/null
+++ b/gcc/testsuite/gcc.target/arm/neon-smin16.c
@@ -0,0 +1,14 @@
+/* { dg-do compile } */
+/* { dg-require-effective-target arm_v8_2a_fp16_neon_ok } */
+/* { dg-add-options arm_v8_2a_fp16_neon } */
+/* { dg-additional-options "-std=c23 -Ofast" } */
+void foo(void);
+extern _Float16 main_in[];
+void bar() {
+  _Float16 out = 0.0;
+  for (int i = 0; i < 100; i++)
+    if (out > main_in[i])
+      out = main_in[i];
+  if (out)
+    foo();
+}

